/*
 *  This file is part of Track & Graph
 *
 *  Track & Graph is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Track & Graph is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Track & Graph.  If not, see <https://www.gnu.org/licenses/>.
 */
package com.samco.trackandgraph.ui.compose.ui

import androidx.compose.foundation.layout.Spacer
import androidx.compose.foundation.layout.height
import androidx.compose.foundation.layout.width
import androidx.compose.runtime.Composable
import androidx.compose.ui.Modifier
import androidx.compose.ui.res.dimensionResource
import com.samco.trackandgraph.R

@Composable
fun SpacingExtraSmall() = Spacer(
    modifier = Modifier
        .height(dimensionResource(id = R.dimen.half_dialog_input_spacing))
        .width(dimensionResource(id = R.dimen.half_dialog_input_spacing))
)

@Composable
fun SpacingCard() = Spacer(
    modifier = Modifier
        .height(dimensionResource(id = R.dimen.card_padding))
        .width(dimensionResource(id = R.dimen.card_padding))
)

@Composable
fun SpacingSmall() = Spacer(
    modifier = Modifier
        .height(dimensionResource(id = R.dimen.dialog_input_spacing))
        .width(dimensionResource(id = R.dimen.dialog_input_spacing))
)

@Composable
fun SpacingLarge() = Spacer(
    modifier = Modifier
        .height(dimensionResource(id = R.dimen.input_spacing_large))
        .width(dimensionResource(id = R.dimen.input_spacing_large))
)
